# 参数说明

| 参数             | 说明                              | 可接受值              | 示例                | 默认值               |
| ---------------- | --------------------------------- | --------------------- | ------------------- | -------------------- |
| ***一般选项：*** |                                   |                       |                     |                      |
| `--version`      | 打印 Natter 版本并退出            | /                     | `--version`         | /                    |
| `--help`         | 打印此帮助并退出                  | /                     | `--help`            | /                    |
| `-v`             | 详细模式，打印调试信息            | /                     | `-v`                | /                    |
| `-q`             | 映射地址改变时立即退出            | /                     | `-q`                | /                    |
| `-u`             | UDP 模式                          | /                     | `-u`                | /                    |
| `-U`             | 启用 UPnP/IGD 发现                | /                     | `-U`                | /                    |
| `-k <interval>`  | 每次保活的间隔秒数                | 整数 >=1              | `-k 20`             | `15`                 |
| `-s <address>`   | STUN 服务器名或地址               | 域名<br>域名:端口号<br>IP地址<br>IP地址:端口号 | `-s stun01.example.com`<br>`-s stun02.example.com:1478`<br>`-s 202.64.12.121`<br>`-s 202.64.12.121:2478` | 内置 STUN 服务器列表 |
| `-h <address>`   | 保活服务器名或地址                | 域名<br>域名:端口号<br>IP地址<br>IP地址:端口号 | `-h example.com`<br>`-h example.com:8080`<br>`-h 202.64.34.101`<br>`-h 202.64.34.101:8888` | TCP模式：<br>`www.baidu.com:80`<br>UDP模式：<br>`8.8.8.8:53` |
| `-e <path>`      | 通知脚本路径                  | 本地文件路径          | `-e /opt/notify.sh` | 无，不启用通知脚本   |
|                  |                                   |                       |                     |                      |
| ***绑定选项：*** |                                   |                       |                     |                      |
| `-i <interface>` | Natter 绑定的网络接口名或 IP 地址 | 网络接口名<br>IP 地址 | `-i eth0`<br>`-i 192.168.1.101` | `0.0.0.0`，绑定默认IP地址 |
| `-b <port>`      | Natter 绑定的端口号               | 整数 0-65535          | `-b 3456`           | `0`，绑定默认端口    |
|                  |                                   |                       |                     |                      |
| ***转发选项：*** |                                   |                       |                     |                      |
| `-m <method>`    | 转发方法                          | 字符串                | `-m none`<br>`-m test`<br>`-m iptables`<br>`-m nftables`<br>`-m socat`<br>`-m gost`<br>`-m socket` | 由其他参数决定为以下某个：<br>`-m test`<br>`-m none`<br>`-m socket` |
| `-t <address>`   | 转发目标的 IP 地址                | IP 地址               | `-t 192.168.1.102`  | 本机 IP 地址         |
| `-p <port>`      | 转发目标的端口号                  | 整数 1-65535          | `-p 80`             | 与公网映射端口号一致 |
| `-r`             | 重试直至目标端口开放              | /                     | `-r`                | /                    |

- TCP 模式中，Natter 使用基于 TCP 的 STUN 协议访问 STUN 服务器，使用 HTTP 协议访问保活服务器；
- UDP 模式中，Natter 使用基于 UDP 的 STUN 协议访问 STUN 服务器，使用 DNS 协议访问保活服务器；
- 部分平台不支持绑定到网络接口，请尝试绑定至接口的 IP 地址；
- 选项 `-r` 用于启动速度很慢的目标程序，避免 Natter 在目标程序准备就绪前提前运作。
- 选项 `-e` 中，关于通知脚本的具体说明，参见 [Natter 通知脚本](script.md) 。
- 选项 `-m` 中，关于转发选项的具体说明，参见 [转发方法](forward.md) 。
